diff --git a/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java b/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
index 21a7614f1..30c75acb6 100644
--- a/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
+++ b/src/main/java/net/minecraft/core/block/RotatableEntityBlock.java
@@ -5,6 +5,7 @@ import net.minecraft.core.entity.Mob;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import org.jetbrains.annotations.NotNull;
 
 public abstract class RotatableEntityBlock extends EntityBlock {
@@ -12,45 +13,23 @@ public abstract class RotatableEntityBlock extends EntityBlock {
 	public RotatableEntityBlock(String key, String namespaceId, int id, Material material) {
         super(key, namespaceId, id, material);
     }
-	public void setDefaultDirection(World world, int x, int y, int z)
-    {
-        if(world.isClientSide)
-        {
-            return;
-        }
-        int idNegZ = world.getBlockId(x, y, z - 1);
-        int idPosZ = world.getBlockId(x, y, z + 1);
-        int idNegX = world.getBlockId(x - 1, y, z);
-        int idPosX = world.getBlockId(x + 1, y, z);
-        Direction direction = Direction.SOUTH;
-        if(Block.solid[idNegZ] && !Block.solid[idPosZ])
-        {
-            direction = Direction.SOUTH;
-        }
-        if(Block.solid[idPosZ] && !Block.solid[idNegZ])
-        {
-            direction = Direction.NORTH;
-        }
-        if(Block.solid[idNegX] && !Block.solid[idPosX])
-        {
-            direction = Direction.EAST;
-        }
-        if(Block.solid[idPosX] && !Block.solid[idNegX])
-        {
-            direction = Direction.WEST;
-        }
-        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, direction));
-    }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
     	world.setBlockMetadataWithNotify(x, y, z, mob.getHorizontalPlacementDirection(side).getOpposite().getId());
     }
 
     @Override
-	public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        if (!side.isHorizontal()) side = Side.NORTH;
+        world.setBlockMetadataWithNotify(x, y, z, side.getOpposite().getId());
+    }
+
+    @Override
+    public void onBlockPlacedByActivator(World world, int x, int y, int z, ActivatorBlockEntity activator, Direction direction)
     {
-        super.onBlockPlacedByWorld(world, x, y, z);
-        setDefaultDirection(world, x, y, z);
+        super.onBlockPlacedByActivator(world, x, y, z, activator, direction);
+        if (direction.getOffsetY() != 0) direction = Direction.NORTH.getOpposite();
+        world.setBlockMetadataWithNotify(x, y, z, RotatableBlock.setDirection(0, direction));
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java b/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
index b03aa8d7a..66e14b858 100644
--- a/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingBaseBlock.java
@@ -76,5 +76,5 @@ public abstract class SaplingBaseBlock extends FlowerBlock implements IBonemeala
         return true;
     }
 
-    public abstract void growTree(World world, int i, int j, int k, Random random);
+    public abstract void growTree(World world, int x, int y, int z, Random random);
 }
diff --git a/src/main/java/net/minecraft/core/block/SaplingBirchBlock.java b/src/main/java/net/minecraft/core/block/SaplingBirchBlock.java
index 8818e28b7..2d3a87c91 100644
--- a/src/main/java/net/minecraft/core/block/SaplingBirchBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingBirchBlock.java
@@ -20,17 +20,17 @@ public class SaplingBirchBlock extends SaplingBaseBlock
 
 
     @Override
-	public void growTree(World world, int i, int j, int k, Random random)
+	public void growTree(World world, int x, int y, int z, Random random)
     {
     	Object obj = null;
 
-    	world.setBlock(i, j, k, 0);
+    	world.setBlock(x, y, z, 0);
 
     	obj = new WorldFeatureTree(Blocks.LEAVES_BIRCH.id, Blocks.LOG_BIRCH.id, 5);
 
-        if(!((WorldFeature) (obj)).place(world, random, i, j, k))
+        if(!((WorldFeature) (obj)).place(world, random, x, y, z))
         {
-            world.setBlock(i, j, k, id);
+            world.setBlock(x, y, z, id);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/SaplingCacaoBlock.java b/src/main/java/net/minecraft/core/block/SaplingCacaoBlock.java
index 1db56e5d2..e7be41576 100644
--- a/src/main/java/net/minecraft/core/block/SaplingCacaoBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingCacaoBlock.java
@@ -15,14 +15,14 @@ public class SaplingCacaoBlock extends SaplingBaseBlock
     }
 
     @Override
-    public void growTree(World world, int i, int j, int k, Random random)
+    public void growTree(World world, int x, int y, int z, Random random)
     {
         Object treeSmall = new WorldFeatureTree(Blocks.LEAVES_CACAO.id, Blocks.LOG_OAK_MOSSY.id, 4);
-        world.setBlock(i, j, k, 0);
+        world.setBlock(x, y, z, 0);
 
-        if(!((WorldFeature) (treeSmall)).place(world, random, i, j, k))
+        if(!((WorldFeature) (treeSmall)).place(world, random, x, y, z))
         {
-                world.setBlock(i, j, k, id);
+                world.setBlock(x, y, z, id);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/SaplingCherryBlock.java b/src/main/java/net/minecraft/core/block/SaplingCherryBlock.java
index 9a8e99d6b..47b143630 100644
--- a/src/main/java/net/minecraft/core/block/SaplingCherryBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingCherryBlock.java
@@ -20,16 +20,16 @@ public class SaplingCherryBlock extends SaplingBaseBlock
     }
 
     @Override
-	public void growTree(World world, int i, int j, int k, Random random)
+	public void growTree(World world, int x, int y, int z, Random random)
     {
         Object treeBig  = new WorldFeatureTreeFancy(Blocks.LEAVES_CHERRY.id, Blocks.LOG_CHERRY.id);
         Object treeSmall = new WorldFeatureTreeCherry(Blocks.LEAVES_CHERRY.id, Blocks.LOG_CHERRY.id, 4);
-        world.setBlock(i, j, k, 0);
+        world.setBlock(x, y, z, 0);
 
-        if(!((WorldFeature) (treeSmall)).place(world, random, i, j, k))
+        if(!((WorldFeature) (treeSmall)).place(world, random, x, y, z))
         {
-            if(!((WorldFeature) (treeBig)).place(world, random, i, j, k)) {
-                world.setBlock(i, j, k, id);
+            if(!((WorldFeature) (treeBig)).place(world, random, x, y, z)) {
+                world.setBlock(x, y, z, id);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/SaplingEucalyptusBlock.java b/src/main/java/net/minecraft/core/block/SaplingEucalyptusBlock.java
index 58c267aa6..64fa1f8e9 100644
--- a/src/main/java/net/minecraft/core/block/SaplingEucalyptusBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingEucalyptusBlock.java
@@ -19,17 +19,17 @@ public class SaplingEucalyptusBlock extends SaplingBaseBlock
     }
     
     @Override
-	public void growTree(World world, int i, int j, int k, Random random)
+	public void growTree(World world, int x, int y, int z, Random random)
     {
     	WorldFeature obj = null;
         
-    	world.setBlock(i, j, k, 0);
+    	world.setBlock(x, y, z, 0);
         
         obj = new WorldFeatureTreeEucalyptus(Blocks.LEAVES_EUCALYPTUS.id, Blocks.LOG_EUCALYPTUS.id);
         obj.init(1.0D, 1.0D, 1.0D);
-        if(!obj.place(world, random, i, j, k))
+        if(!obj.place(world, random, x, y, z))
         {
-            world.setBlock(i, j, k, id);
+            world.setBlock(x, y, z, id);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/SaplingOakBlock.java b/src/main/java/net/minecraft/core/block/SaplingOakBlock.java
index a4b0410c2..4a1365258 100644
--- a/src/main/java/net/minecraft/core/block/SaplingOakBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingOakBlock.java
@@ -20,16 +20,16 @@ public class SaplingOakBlock extends SaplingBaseBlock
     }
     
     @Override
-	public void growTree(World world, int i, int j, int k, Random random)
+	public void growTree(World world, int x, int y, int z, Random random)
     {
     	Object treeBig = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id);
         Object treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK.id, Blocks.LOG_OAK.id, 4);
-    	world.setBlock(i, j, k, 0);
+    	world.setBlock(x, y, z, 0);
 
-        if(!((WorldFeature) (treeSmall)).place(world, random, i, j, k))
+        if(!((WorldFeature) (treeSmall)).place(world, random, x, y, z))
         {
-            if(!((WorldFeature) (treeBig)).place(world, random, i, j, k)) {
-                world.setBlock(i, j, k, id);
+            if(!((WorldFeature) (treeBig)).place(world, random, x, y, z)) {
+                world.setBlock(x, y, z, id);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/SaplingPineBlock.java b/src/main/java/net/minecraft/core/block/SaplingPineBlock.java
index dec0a43db..901b049c6 100644
--- a/src/main/java/net/minecraft/core/block/SaplingPineBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingPineBlock.java
@@ -42,17 +42,17 @@ public class SaplingPineBlock extends SaplingBaseBlock
     }
     
     @Override
-	public void growTree(World world, int i, int j, int k, Random random)
+	public void growTree(World world, int x, int y, int z, Random random)
     {
         Object treeBig  = new WorldFeatureTreeTaigaTall(Blocks.LEAVES_PINE.id, Blocks.LOG_PINE.id);
         Object treeSmall = new WorldFeatureTreeTaigaBushy(Blocks.LEAVES_PINE.id, Blocks.LOG_PINE.id);
         
-    	world.setBlock(i, j, k, 0);
+    	world.setBlock(x, y, z, 0);
 
-        if(!((WorldFeature) (treeSmall)).place(world, random, i, j, k))
+        if(!((WorldFeature) (treeSmall)).place(world, random, x, y, z))
         {
-            if(!((WorldFeature) (treeBig)).place(world, random, i, j, k)) {
-                world.setBlock(i, j, k, id);
+            if(!((WorldFeature) (treeBig)).place(world, random, x, y, z)) {
+                world.setBlock(x, y, z, id);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/SaplingRetroBlock.java b/src/main/java/net/minecraft/core/block/SaplingRetroBlock.java
index c4ac5780e..f378b2f96 100644
--- a/src/main/java/net/minecraft/core/block/SaplingRetroBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingRetroBlock.java
@@ -21,16 +21,16 @@ public class SaplingRetroBlock extends SaplingBaseBlock
 
 
     @Override
-	public void growTree(World world, int i, int j, int k, Random random)
+	public void growTree(World world, int x, int y, int z, Random random)
     {
         Object treeBig  = new WorldFeatureTreeFancy(Blocks.LEAVES_OAK_RETRO.id, Blocks.LOG_OAK.id);
         Object treeSmall = new WorldFeatureTree(Blocks.LEAVES_OAK_RETRO.id, Blocks.LOG_OAK.id, 4);
-        world.setBlock(i, j, k, 0);
+        world.setBlock(x, y, z, 0);
 
-        if(!((WorldFeature) (treeSmall)).place(world, random, i, j, k))
+        if(!((WorldFeature) (treeSmall)).place(world, random, x, y, z))
         {
-            if(!((WorldFeature) (treeBig)).place(world, random, i, j, k)) {
-                world.setBlock(i, j, k, id);
+            if(!((WorldFeature) (treeBig)).place(world, random, x, y, z)) {
+                world.setBlock(x, y, z, id);
             }
         }
     }
diff --git a/src/main/java/net/minecraft/core/block/SaplingShrubBlock.java b/src/main/java/net/minecraft/core/block/SaplingShrubBlock.java
index ff81de64a..b77d4a015 100644
--- a/src/main/java/net/minecraft/core/block/SaplingShrubBlock.java
+++ b/src/main/java/net/minecraft/core/block/SaplingShrubBlock.java
@@ -19,17 +19,17 @@ public class SaplingShrubBlock extends SaplingBaseBlock
     }
     
     @Override
-	public void growTree(World world, int i, int j, int k, Random random)
+	public void growTree(World world, int x, int y, int z, Random random)
     {
     	Object obj = null;
         
-    	world.setBlock(i, j, k, 0);
+    	world.setBlock(x, y, z, 0);
         
     	obj = new WorldFeatureTreeShrub(Blocks.LEAVES_SHRUB.id, Blocks.LOG_OAK.id);
         
-        if(!((WorldFeature) (obj)).place(world, random, i, j, k))
+        if(!((WorldFeature) (obj)).place(world, random, x, y, z))
         {
-            world.setBlock(i, j, k, id);
+            world.setBlock(x, y, z, id);
         }
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/SlabBlock.java b/src/main/java/net/minecraft/core/block/SlabBlock.java
index d640de755..86513126a 100644
--- a/src/main/java/net/minecraft/core/block/SlabBlock.java
+++ b/src/main/java/net/minecraft/core/block/SlabBlock.java
@@ -188,8 +188,8 @@ public class SlabBlock extends Block
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
-    	Direction dir = mob.getVerticalPlacementDirection(side, sideHeight);
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
+    	Direction dir = mob.getVerticalPlacementDirection(side, yPlaced);
     	if(dir == Direction.DOWN) {
             world.setBlockMetadataWithNotify(x, y, z, 0);
     	}
@@ -197,6 +197,15 @@ public class SlabBlock extends Block
             world.setBlockMetadataWithNotify(x, y, z, 2);
     	}
     }
+
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        if(side == Side.TOP) {
+            world.setBlockMetadataWithNotify(x, y, z, 2);
+        } else {
+            world.setBlockMetadataWithNotify(x, y, z, 0);
+        }
+    }
     
     @Override
 	public void onBlockPlacedByWorld(World world, int x, int y, int z)
diff --git a/src/main/java/net/minecraft/core/block/SnowLayerBlock.java b/src/main/java/net/minecraft/core/block/SnowLayerBlock.java
index 60271389c..d8f08df6a 100644
--- a/src/main/java/net/minecraft/core/block/SnowLayerBlock.java
+++ b/src/main/java/net/minecraft/core/block/SnowLayerBlock.java
@@ -71,22 +71,12 @@ public class SnowLayerBlock extends BaseLayerBlock
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        func_314_h(world, x, y, z);
-    }
-
-    private boolean func_314_h(World world, int i, int j, int k)
-    {
-        if(!canPlaceBlockAt(world, i, j, k))
-        {
-            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
-            world.setBlockWithNotify(i, j, k, 0);
-            return false;
-        } else
-        {
-            return true;
+        // Remove if no longer valid
+        if (!canPlaceBlockAt(world, x, y, z)) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+            world.setBlockWithNotify(x, y, z, 0);
         }
     }
-
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
     {
diff --git a/src/main/java/net/minecraft/core/block/SpikesBlock.java b/src/main/java/net/minecraft/core/block/SpikesBlock.java
index 7eb59e2d6..e703356fa 100644
--- a/src/main/java/net/minecraft/core/block/SpikesBlock.java
+++ b/src/main/java/net/minecraft/core/block/SpikesBlock.java
@@ -8,6 +8,7 @@ import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
@@ -17,6 +18,7 @@ import org.jetbrains.annotations.NotNull;
 
 public class SpikesBlock extends Block
 {
+    public static final int MASK_POWERED = 0b0000_0001;
 
     public SpikesBlock(String key, String namespaceId, int id, Material mat)
     {
@@ -24,14 +26,14 @@ public class SpikesBlock extends Block
     }
 
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
         if (world.isClientSide) {
             return;
         }
 
         int meta = world.getBlockMetadata(x, y, z);
         if(world.hasNeighborSignal(x, y, z)) {
-            world.setBlockMetadataWithNotify(x, y, z, meta | 1);
+            world.setBlockMetadataWithNotify(x, y, z, meta | MASK_POWERED);
         }
     }
 
@@ -61,15 +63,15 @@ public class SpikesBlock extends Block
 		}
 
 		int meta = world.getBlockMetadata(x, y, z);
-		boolean wasPowered = (meta & 1) > 0;
+		boolean wasPowered = (meta & MASK_POWERED) != 0;
 		boolean isPowered = world.hasNeighborSignal(x, y, z);
 		
 		if(isPowered != wasPowered) {
 			if(isPowered) {
-				world.playBlockEvent(null, 1007, x, y, z, 0);
-				world.setBlockMetadataWithNotify(x, y, z, 1);
+				world.playBlockEvent(null, LevelListener.EVENT_PISTON_RETRACT, x, y, z, 0);
+				world.setBlockMetadataWithNotify(x, y, z, MASK_POWERED);
 			}else {
-				world.playBlockEvent(null, 1006, x, y, z, 0);
+				world.playBlockEvent(null, LevelListener.EVENT_PISTON_EXTEND, x, y, z, 0);
 				world.setBlockMetadataWithNotify(x, y, z, 0);
 			}
 		}
@@ -105,7 +107,7 @@ public class SpikesBlock extends Block
     
     public static boolean isSpikesUp(int i)
     {
-        return (i & 1) != 1;
+        return (i & MASK_POWERED) == 0;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/StairsBlock.java b/src/main/java/net/minecraft/core/block/StairsBlock.java
index 39336b3c0..da7d7c494 100644
--- a/src/main/java/net/minecraft/core/block/StairsBlock.java
+++ b/src/main/java/net/minecraft/core/block/StairsBlock.java
@@ -307,7 +307,7 @@ public class StairsBlock extends Block
     }
     
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
 //    	System.out.println("Placed Side: "+side+" Height: "+sideHeight);
     	
         int meta = world.getBlockMetadata(x, y, z) & 0xF0;
@@ -318,13 +318,32 @@ public class StairsBlock extends Block
         if(hRotation == Direction.SOUTH) meta |= 0b0011;
         if(hRotation == Direction.WEST) meta |= 0b0000;
 
-        Direction vRotation = mob.getVerticalPlacementDirection(side, sideHeight);
+        Direction vRotation = mob.getVerticalPlacementDirection(side, yPlaced);
         if (vRotation == Direction.DOWN) meta |= 0b0000;
         if (vRotation == Direction.UP) meta |= 0b1000;
 
         world.setBlockMetadataWithNotify(x, y, z, meta);
     }
-    
+
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        int meta = world.getBlockMetadata(x, y, z) & 0xF0;
+
+        Side hSide = !side.isHorizontal() ? Side.NORTH : side;
+        Direction hRotation = side.getOpposite().getDirection();
+        if(hRotation == Direction.NORTH) meta |= 0b0010;
+        if(hRotation == Direction.EAST) meta |= 0b0001;
+        if(hRotation == Direction.SOUTH) meta |= 0b0011;
+        if(hRotation == Direction.WEST) meta |= 0b0000;
+
+        Side vSide = !side.isVertical() ? Side.BOTTOM : side;
+        Direction vRotation = vSide.getDirection();
+        if (vRotation == Direction.DOWN) meta |= 0b0000;
+        if (vRotation == Direction.UP) meta |= 0b1000;
+
+        world.setBlockMetadataWithNotify(x, y, z, meta);
+    }
+
     @Override
     public float getAmbientOcclusionStrength(WorldSource blockAccess, int x, int y, int z) {
     	return 0.0f;
diff --git a/src/main/java/net/minecraft/core/block/StillFluidBlock.java b/src/main/java/net/minecraft/core/block/StillFluidBlock.java
index 309865dcf..5e9e11587 100644
--- a/src/main/java/net/minecraft/core/block/StillFluidBlock.java
+++ b/src/main/java/net/minecraft/core/block/StillFluidBlock.java
@@ -29,13 +29,13 @@ public class StillFluidBlock extends FluidBlock
         }
     }
 
-    private void setFlowing(World world, int i, int j, int k)
+    private void setFlowing(World world, int x, int y, int z)
     {
-        int l = world.getBlockMetadata(i, j, k);
+        int meta = world.getBlockMetadata(x, y, z);
         world.noNeighborUpdate = true;
-        world.setBlockAndMetadata(i, j, k, id - 1, l);
-        world.markBlocksDirty(i, j, k, i, j, k);
-        world.scheduleBlockUpdate(i, j, k, id - 1, tickDelay());
+        world.setBlockAndMetadata(x, y, z, id - 1, meta);
+        world.markBlocksDirty(x, y, z, x, y, z);
+        world.scheduleBlockUpdate(x, y, z, id - 1, tickDelay());
         world.noNeighborUpdate = false;
     }
 
diff --git a/src/main/java/net/minecraft/core/block/SugarcaneBlock.java b/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
index 261a510c6..3337905eb 100644
--- a/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
+++ b/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
@@ -98,12 +98,12 @@ public class SugarcaneBlock extends Block implements IBonemealable
         checkBlockCoordValid(world, x, y, z);
     }
 
-    protected final void checkBlockCoordValid(World world, int i, int j, int k)
+    protected final void checkBlockCoordValid(World world, int x, int y, int z)
     {
-        if(!canBlockStay(world, i, j, k))
+        if(!canBlockStay(world, x, y, z))
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, i, j, k, world.getBlockMetadata(i, j, k), null, null);
-            world.setBlockWithNotify(i, j, k, 0);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+            world.setBlockWithNotify(x, y, z, 0);
         }
     }
 
